<?php

require_once ('class.SQLQueries.php');

class Data {

	//	const HOST = "mysql12.000webhost.co";
	//	const USER = "a9478101_chart";
	//	const PASSWORD = "wh666th";
	//	const DATABASE = "a9478101_chart";
	const HOST = "localhost";
	const USER = "root";
	const PASSWORD = "";
	const DATABASE = "frequenz";

	const LAST_TIME = "SELECT zeit FROM frequenzmessung
		ORDER BY id DESC LIMIT 1;";
	const LAST_VALUE = "SELECT messwert FROM frequenzmessung
		ORDER BY id DESC LIMIT 1;";
	const DATA_DAY = "SELECT zeit,messwert FROM frequenzmessung
		WHERE DATE_SUB((SELECT max(zeit) FROM frequenzmessung),INTERVAL 1 DAY) <= zeit";
	const DATA_WEEK = "SELECT zeit,messwert FROM frequenzmessung
		WHERE DATE_SUB((SELECT max(zeit) FROM frequenzmessung),INTERVAL 7 DAY) <= zeit";
	const DATA_HOUR = "SELECT zeit,messwert FROM frequenzmessung
		WHERE DATE_SUB((SELECT max(zeit) FROM frequenzmessung),INTERVAL 1 HOUR) <= zeit";

	private static $FAVOURITES=array(
		"getWeek"=>Data::DATA_WEEK,
		"getDay"=>Data::DATA_DAY,
		"getHour"=>Data::DATA_HOUR,
	);

	private static $defaultMethod ="getHour";

	private $lastValue="";
	private $lastTime="";
	private $getParas;

	function __construct($getParas){
		$this->initParameter($getParas);
		$this->init();
	}

	public function init(){

		$db = @new mysqli(Data::HOST, Data::USER, Data::PASSWORD, Data::DATABASE);
		if (mysqli_connect_errno() == 0)
		{
			//Label1
			$sql = Data::LAST_VALUE;
			$ergebnis = $db->query( $sql );
			while ($zeile = $ergebnis->fetch_object())
			{
				$this->lastValue = $zeile->messwert;
			}

			//Label
			$sql = Data::LAST_TIME;
			$ergebnis = $db->query( $sql );
			while ($zeile = $ergebnis->fetch_object())
			{
				$this->lastTime = $zeile->zeit;
			}

			//Chart-Data
			$sql = $this->getFavourite();
			$this->data=$sql;
			$ergebnis = $db->query( $sql );
			$temp=array();
			//Reduzierung der Datenmenge
			if($ergebnis->num_rows>1000){
				//Anzahl der Datenstze, die gemittelt werden
				$combinedRows = $ergebnis->num_rows / 1000;
				for ($k=0; $k<$ergebnis->num_rows; $k=$k+$combinedRows)
				{
					//Ein Datensatz zusammenfassen
					$combinedRowArr=array();
					for ($s=0; $s<$combinedRows; $s++)
					{
						if($zeile = $ergebnis->fetch_object()){
							$combinedRowArr[$s]=$zeile->messwert;
						}
					}
					if (($timestamp = strtotime($zeile->zeit)) !== false) {
						//Mittelung
						$temp[]=array(-$timestamp*1000,array_sum($combinedRowArr)/count($combinedRowArr));
					}
				}
			}
			else{
				while ($zeile = $ergebnis->fetch_object())
				{
					if (($timestamp = strtotime($zeile->zeit)) !== false) {
						$temp[]=array(-$timestamp*1000,$zeile->messwert);
					}
				}
			}
			$this->data =$temp;

			$ergebnis->close();
		} else {
			// Es konnte keine Datenbankverbindung aufgebaut werden
			echo 'Die Datenbank konnte nicht erreicht werden. Folgender Fehler trat auf: <span class="hinweis">' .mysqli_connect_errno(). ' : ' .mysqli_connect_error(). '</span>';
		}
		$db->close();
	}

	private function getFavourite(){
		return self::$FAVOURITES[$this->getParas['favourite']];
	}
	private function initParameter($getParas){
		$this->getParas=$getParas;
		if(!isset($this->getParas['favourite']))$this->getParas['favourite']=self::$defaultMethod;
	}

	public function getFavourites(){
		return array(
			"getWeek" => "7 Tage",
			"getDay" =>"1 Tag",
			"getHour" =>"1 Stunde"
			);
	}
	public function getHeaderLabel1(){
		$arr=$this->getFavourites();
		return $arr[$this->getParas['favourite']];
	}
	public function getHeaderLabel2(){
		return $this->lastValue;
	}
	public function getHeaderLabel3(){
		if (($timestamp = strtotime($this->lastTime)) === false) {
			return "Die Zeichenkette ($str) ist nicht parsebar.";
		} else {
			return date('j.n.Y H:i:s \U\h\r', $timestamp);
		}
	}
	public function getChartData(){
		return $this->data;
	}
}